var xdebughelper_state_idekey = 'default';
window.addEventListener("load", xdebughelper_init, false);

function xdebughelper_init(){
	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	xdebughelper_state_idekey = prefManager.getCharPref("extensions.xdebughelper.idekey");
	getBrowser().addEventListener("select", xdebughelper_refresh_ui, false);
	getBrowser().addEventListener("load",xdebughelper_refresh_ui, true);
}

function xdebughelper_toggle(){
	var doc=window.content.document;

	var isEnabled = (xdebughelper_getCookie(doc,'XDEBUG_SESSION')==xdebughelper_state_idekey);
	xdebughelper_setCookie(doc,'XDEBUG_SESSION',isEnabled?null:xdebughelper_state_idekey,isEnabled?-60:60);

	xdebughelper_refresh_ui();
}

function xdebughelper_toggle_profiler(){
	var doc=window.content.document;

	var isEnabled = (xdebughelper_getCookie(doc,'XDEBUG_PROFILE')==1);
	xdebughelper_setCookie(doc,'XDEBUG_PROFILE',isEnabled?null:1,isEnabled?-60:60);

	xdebughelper_refresh_ui();
}

function xdebughelper_refresh_ui(){
	var doc=window.content.document;
	var isEnabled = (xdebughelper_getCookie(doc,'XDEBUG_SESSION')==xdebughelper_state_idekey);
	var icon = document.getElementById('xdebughelper_sbi');
	if(isEnabled){
		icon.src="chrome://xdebughelper/content/images/sbi-on-16x16.png";
		icon.tooltiptext="Stop xdebug session";
	}else{
		icon.src="chrome://xdebughelper/content/images/sbi-off-16x16.png";
		icon.tooltiptext="Start xdebug session";
	}
  
	var isProfilerEnabled = (xdebughelper_getCookie(doc,'XDEBUG_PROFILE')==1);
	var profilerIcon = document.getElementById('xdebughelper_profiler');
	if(isProfilerEnabled){
		profilerIcon.src="chrome://xdebughelper/content/images/xdebug-profiler-on.png";
		profilerIcon.tooltiptext="Stop xdebug profiler";
	}else{
		profilerIcon.src="chrome://xdebughelper/content/images/xdebug-profiler-off.png";
		profilerIcon.tooltiptext="Start xdebug profiler";
	}
}

function xdebughelper_setCookie(doc,cookieName, cookieVal,minutes) {
    var exp=new Date();
    exp.setTime(exp.getTime()+(minutes*60*1000));
    doc.cookie=cookieName+"="+cookieVal+"; expires="+exp.toGMTString()+"; path=/";
}
function xdebughelper_getCookie(doc,name) {
    var prefix = name + "="
    var cookieStartIndex = doc.cookie.indexOf(prefix)
    if (cookieStartIndex == -1)
            return null
    var cookieEndIndex = doc.cookie.indexOf(";", cookieStartIndex + prefix.length)
    if (cookieEndIndex == -1)
            cookieEndIndex = doc.cookie.length
    return unescape(doc.cookie.substring(cookieStartIndex + prefix.length, cookieEndIndex))
}
